std::optional< _Tp > Class Template Reference
Utilities
Inheritance diagram for std::optional< _Tp >:
[legend]

## Public Types

using | value_type = _Tp

## Public Member Functions

template<typename _Up = _Tp, _Requires< __not_self< _Up >, __not_tag< _Up >, is_constructible< _Tp, _Up >, is_convertible< _Up, _Tp >> = true>
constexpr | optional (_Up &&__t) noexcept(is_nothrow_constructible_v< _Tp, _Up >)
template<typename _Up = _Tp, _Requires< __not_self< _Up >, __not_tag< _Up >, is_constructible< _Tp, _Up >, __not_< is_convertible< _Up, _Tp >>> = false>
constexpr | optional (_Up &&__t) noexcept(is_nothrow_constructible_v< _Tp, _Up >)
template<typename _Up , _Requires< __not_< is_same< _Tp, _Up >>, is_constructible< _Tp, const _Up & >, is_convertible< const _Up &, _Tp >, __not_< __converts_from_optional< _Tp, _Up >>> = true>
constexpr | optional (const optional< _Up > &__t) noexcept(is_nothrow_constructible_v< _Tp, const _Up & >)
template<typename _Up , _Requires< __not_< is_same< _Tp, _Up >>, is_constructible< _Tp, const _Up & >, __not_< is_convertible< const _Up &, _Tp >>, __not_< __converts_from_optional< _Tp, _Up >>> = false>
constexpr | optional (const optional< _Up > &__t) noexcept(is_nothrow_constructible_v< _Tp, const _Up & >)
template<typename... _Args, _Requires< is_constructible< _Tp, _Args... >> = false>
constexpr | optional (in_place_t, _Args &&... __args) noexcept(is_nothrow_constructible_v< _Tp, _Args... >)
template<typename _Up , typename... _Args, _Requires< is_constructible< _Tp, initializer_list< _Up > &, _Args... >> = false>
constexpr | optional (in_place_t, initializer_list< _Up > __il, _Args &&... __args) noexcept(is_nothrow_constructible_v< _Tp, initializer_list< _Up > &, _Args... >)
constexpr | optional (nullopt_t) noexcept
template<typename _Up , _Requires< __not_< is_same< _Tp, _Up >>, is_constructible< _Tp, _Up >, is_convertible< _Up, _Tp >, __not_< __converts_from_optional< _Tp, _Up >>> = true>
constexpr | optional (optional< _Up > &&__t) noexcept(is_nothrow_constructible_v< _Tp, _Up >)
template<typename _Up , _Requires< __not_< is_same< _Tp, _Up >>, is_constructible< _Tp, _Up >, __not_< is_convertible< _Up, _Tp >>, __not_< __converts_from_optional< _Tp, _Up >>> = false>
constexpr | optional (optional< _Up > &&__t) noexcept(is_nothrow_constructible_v< _Tp, _Up >)
template<typename... _Args>
constexpr enable_if_t< is_constructible_v< _Tp, _Args... >, _Tp & > | emplace (_Args &&... __args) noexcept(is_nothrow_constructible_v< _Tp, _Args... >)
template<typename _Up , typename... _Args>
constexpr enable_if_t< is_constructible_v< _Tp, initializer_list< _Up > &, _Args... >, _Tp & > | emplace (initializer_list< _Up > __il, _Args &&... __args) noexcept(is_nothrow_constructible_v< _Tp, initializer_list< _Up > &, _Args... >)
constexpr bool | has_value () const noexcept
constexpr | operator bool () const noexcept
constexpr _Tp && | operator* () &&noexcept
constexpr _Tp & | operator* () &noexcept
constexpr const _Tp && | operator* () const &&noexcept
constexpr const _Tp & | operator* () const &noexcept
constexpr const _Tp * | operator-> () const noexcept
constexpr _Tp * | operator-> () noexcept
template<typename _Up = _Tp>
constexpr enable_if_t< __and_v< __not_self< _Up >, __not_< __and_< is_scalar< _Tp >, is_same< _Tp, decay_t< _Up > > > >, is_constructible< _Tp, _Up >, is_assignable< _Tp &, _Up > >, optional & > | operator= (_Up &&__u) noexcept(__and_v< is_nothrow_constructible< _Tp, _Up >, is_nothrow_assignable< _Tp &, _Up >>)
template<typename _Up >
constexpr enable_if_t< __and_v< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, const _Up & >, is_assignable< _Tp &, const _Up & >, __not_< __converts_from_optional< _Tp, _Up > >, __not_< __assigns_from_optional< _Tp, _Up > > >, optional & > | operator= (const optional< _Up > &__u) noexcept(__and_v< is_nothrow_constructible< _Tp, const _Up & >, is_nothrow_assignable< _Tp &, const _Up & >>)
constexpr optional & | operator= (nullopt_t) noexcept
template<typename _Up >
constexpr enable_if_t< __and_v< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, _Up >, is_assignable< _Tp &, _Up >, __not_< __converts_from_optional< _Tp, _Up > >, __not_< __assigns_from_optional< _Tp, _Up > > >, optional & > | operator= (optional< _Up > &&__u) noexcept(__and_v< is_nothrow_constructible< _Tp, _Up >, is_nothrow_assignable< _Tp &, _Up >>)
constexpr void | reset () noexcept
constexpr void | swap (optional &__other) noexcept(is_nothrow_move_constructible_v< _Tp > &&is_nothrow_swappable_v< _Tp >)
constexpr _Tp & | value () &
constexpr _Tp && | value () &&
constexpr const _Tp & | value () const &
constexpr const _Tp && | value () const &&
template<typename _Up >
constexpr _Tp | value_or (_Up &&__u) &&
template<typename _Up >
constexpr _Tp | value_or (_Up &&__u) const &

## Detailed Description

### template<typename _Tp>
class std::optional< _Tp >

Class template for optional values.

Definition at line 662 of file optional.

The documentation for this class was generated from the following file:

- optional